// TODO: allow keyboard selection (press 1-4 to guess)
// TODO: massive cleanup of code/html/css
// TODO: rearrange windows to make room for running progress report,
//	showing number of correct guesses and number of remaining cards
//	in the deck (replacing results window, which isn't terribly
//	useful).
// TODO: add Dashboard extensions so it will work correctly as a
//	gadget (need to poke holes through to accept clicks, and
//	create the UI for flipping between prefs and quiz).
// TODO: set/save/restore settings (Dashboard only)
// TODO: add delay/hide modes where display of the question is suppressed
//	before you have to answer. (down the road...)

var deck = new Array;
var quiz = new Array;
var quizq;
var quiza;
var setsused = new Array;

var numerrors;
var correct;
var wrong = new Array;
var topcard;
var obj = new Object;

window.captureEvents(Event.KEYPRESS);
window.onkeydown = keyPressed;

function keyPressed(e) {
	if (front.style.display == "block") {
		e.stopPropagation();
		e.preventDefault();
		evalguess(String.fromCharCode(e.charCode) - 1);
	}else if (results.style.display == "block") {
		e.stopPropagation();
		e.preventDefault();
		gotoprefs();
	}
}

function evalguess(num) {
	obj = document.getElementById(num == correct ?
		"correct" : "incorrect");
	obj.style.display = "block";
	setTimeout("endfeedback()",500);
	if (num != correct) {
		numerrors++;
		deck.push(topcard);
	}
	return (num == correct);
}
function endfeedback() {
		obj.style.display = "none";
		showtopcard();
}

// startquiz - process the options form, switch to the
//	"front" of the gadget, and start the quiz
//
function startquiz(form) {
	quizq = form.question.value;
	quiza = form.answer.value;
	setsused.length = 0;
	for (i=0;i<=26;i++) {
		if (form.sets[i].checked)
			setsused.push(form.sets[i].value);
	}

	quiz.length = 0;
	for (i=0;i<setsused.length;i++) {
		quiz = quiz.concat(quizsets[setsused[i]]);
	}
	if (quiz.length > 3) {
		deck.length = 0;
		for (i=0;i<quiz.length;i++) {
			deck[i]=i;
		}
		shuffle(deck);
		numerrors=0;
		showtopcard();

		if (gadget)
			gadget.finishEdit();
		back.style.display = "none";
		front.style.display="block";
		if (gadget) {
			gadget.openControlRects();
			gadget.clearAllControlRects();
			gadget.addControlRect(15,150,50,30);
			gadget.addControlRect(75,150,50,30);
			gadget.addControlRect(135,150,50,30);
			gadget.addControlRect(195,150,50,30);
			gadget.closeControlRects();
			setTimeout ('gadget.runEditTransition();', 0);
	        }
	}else{
		alert("Not enough choices in selected groups! Select more.");
		gotoprefs();
	}
}

// showtopcard - reveal the next card of the deck and generate
//	a list of possible answers, only one of which is correct
//
function showtopcard() {
	if (deck.length > 0) {
		topcard = deck.shift();
		var guesses = guess.getElementsByTagName("div");
		correct = Math.floor(Math.random()*guesses.length);
		wrong = badguesses(topcard,guesses.length);

		var tmp = document.createTextNode(quiz[topcard][quizq]);
		question.replaceChild(tmp,question.firstChild);
		for (i=0;i<guesses.length; i++) {
			var tmp = document.createTextNode(
				quiz[i==correct ? topcard : wrong[i]][quiza]);
			guesses[i].replaceChild(tmp,guesses[i].firstChild);
		}
	}else{
		errorcount.firstChild.nodeValue = numerrors;
		totalcount.firstChild.nodeValue = quiz.length;
		results.style.display = "block";
		front.style.display="none";
		back.style.display = "none";
	}
}

function gotoprefs() {
	if (gadget)
		gadget.startEdit();
	results.style.display = "none";
	front.style.display = "none";
	back.style.display = "block";
	if (gadget) {
		gadget.openControlRects();
		gadget.clearAllControlRects();
		gadget.addControlRect(5,5,250,180);   // entire form
		gadget.closeControlRects();
		setTimeout ('gadget.runEditTransition();', 0);
        }

}

// generate a list of incorrect guesses for the current flashcard
//
function badguesses(card,count) {
	tmpary = new Array;
	for (i=0;i<quiz.length;i++) {
		if (i != card) {tmpary.push(i);}
	}
	shuffle(tmpary);
	return tmpary.slice(0,count);
}

/* Bentley's perfect shuffle; note that ary is passed by reference! */
function shuffle(ary) {
	var i;
	for(i=0;i<ary.length;i++) {
		var n = Math.floor(Math.random()*i);
		var tmp = ary[n];
		ary[n] = ary[i];
		ary[i] = tmp;
	}
}
